/*
 * Created on Jul 18, 2005
 *
 * This class contains tests of the sum function in SomeClass
 */

/**
 * @author erika
 */
import org.junit.*; 
import static org.junit.Assert.*;

public class SomeClassTest {
    /* 
     * testSumNoNums: Creates an array of three elements and finds
     * the sum of the first two elements.
     *
     * Expected result: The sum is 0
     */
    @Test
    public void testSumNoNums() {
        scla = new SomeClass();
        nums = new int[3];
        nums[0] = 1;
        nums[1] = 2;
        nums[2] = 3;
        assertEquals("sum none test", 0, scla.sum(nums, 0));
    }

    /* 
     * testSumTwoNums: Creates an array of three elements and finds
     * the sum of the first two elements.
     *
     * Expected result: The sum is 3
     */
    @Test
    public void testSumTwoNums() {
        scla = new SomeClass();
        nums = new int[3];
        nums[0] = 1;
        nums[1] = 2;
        nums[2] = 3;
        assertEquals("sum two test", 3, scla.sum(nums, 2));
    }

    /* 
     * testSumAllNums: Creates an array of three elements and finds
     * the sum of all the elements in the array. 
     *
     * Expected result: The sum is 6
     */
    @Test 
    public void testSumAllNums() {
        scla = new SomeClass();
        nums = new int[3];
        nums[0] = 1;
        nums[1] = 2;
        nums[2] = 3;
        assertEquals("sum all test", 6, scla.sum(nums, 3));
    }

    /* 
     * testSumLargerThanArray: Creates an array of three elements and
     * finds the sum of the first 4. 
     *
     * Expected result: The sum is 6 (all elements in the array)
     *
     * This test will fail with the original version of sum. 
     */
    @Test 
    public void testBeyondBounds() {
        scla = new SomeClass();
        nums = new int[3];
        nums[0] = 1;
        nums[1] = 2;
        nums[2] = 3;
        assertEquals("beyond bounds test", 6, scla.sum(nums, 4));
    }
    
    private SomeClass scla;
    private int[] nums;
}
